import javax.xml.parsers.*; 
import javax.xml.transform.*;

import java.io.*;

//
//	Create a fractal from two XML files.
//  Kwok-Bun Yue
//  April 2, 2003.
//	See: http://dcm.cl.uh.edu/yue/courses/xml/Spring2003/hw/h4.asp
//	Minimally documented.
//
public class CreateFractal {

	public CreateFractal() {
	}	//	no-arg News

	//	main 
	public static void main(String[] args) 
	{
		try {
			if (args.length != 5) {
				System.out.println("Usage: java CreateFractal inputBaseFractal.svg fratcalTransform.xml fractOption.xml generateFractal.xsl outputFractal.svg");
				System.exit(0);
			}

			//	Input parameters.

			String inputBaseFractal = args[0];
			String fractalTransform = args[1];
			String fractalOption = args[2];
			String generateFractal = args[3];
			String outputFractal = args[4];

			//   Transform and output.
	
			//   out.println("source => " + application.getRealPath("/" + xslSourceFilename) + "<p>");
			javax.xml.transform.TransformerFactory tFactory = 
				javax.xml.transform.TransformerFactory.newInstance();
			// Get the XML input document and the stylesheet.
			javax.xml.transform.Source xmlSource = 
				new javax.xml.transform.stream.StreamSource(new File(inputBaseFractal));

			javax.xml.transform.Source xslSource = 
				new javax.xml.transform.stream.StreamSource(new File(generateFractal));
      
			// Generate the transformer.
			javax.xml.transform.Transformer transformer = tFactory.newTransformer(xslSource);

			//   Pass the file names for the transformation and option.
			transformer.setParameter("transformationFile", fractalTransform);    
			transformer.setParameter("optionFile", fractalOption);    

			// Perform the transformation, sending the output to the response.
			transformer.transform(xmlSource, new javax.xml.transform.stream.StreamResult(
				new PrintWriter(new FileOutputStream(outputFractal))));
		}
		//	If an exception occurs, return the error to the client.
		catch (Exception e)
		{
			System.out.println("Sorry, error: \n" + e.getMessage() + "\n  Stack: \n");
			e.printStackTrace(System.out);
		}
	}	//	main
};	//	CreateFractal
